Bug 1204898 - Review Request: libntirpc - New Transport Independent RPC library for NFS-Ganesha
Summary: Review Request: libntirpc - New Transport Independent RPC library for NFS-Gan...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Zbigniew Jędrzejewski-Szmek
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-03-23 17:30 UTC by Kaleb KEITHLEY
Modified: 2015-04-21 19:18 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-03-31 11:41:13 UTC
Type: ---
zbyszek: fedora-review+
puiterwijk: fedora-cvs+


Attachments (Terms of Use)

Description Kaleb KEITHLEY 2015-03-23 17:30:35 UTC
Spec URL: https://kkeithle.fedorapeople.org/libntirpc.spec
SRPM URL: https://kkeithle.fedorapeople.org/libntirpc-1.2.1-1.fc21.src.rpm
Description: (libntirpc was originally bundled in nfs-ganesha with a bundling exception granted through Fedora 23 on  https://fedorahosted.org/fpc/ticket/363)
This package contains a new implementation of the original libtirpc,
transport-independent RPC (TI-RPC) library for NFS-Ganesha. It has
the following features not found in libtirpc:
 1. Bi-directional operation
 2. Full-duplex operation on the TCP (vc) transport
 3. Thread-safe operating modes
 3.1 new locking primitives and lock callouts (interface change)
 3.2 stateless send/recv on the TCP transport (interface change)
 4. Flexible server integration support
 5. Event channels (remove static arrays of xprt handles, new EPOLL/KEVENT
    integration)
Fedora Account System Username: kkeithle

Comment 1 Kaleb KEITHLEY 2015-03-23 19:30:12 UTC
koji scratch build http://koji.fedoraproject.org/koji/taskinfo?taskID=9305364

Comment 2 Zbigniew Jędrzejewski-Szmek 2015-03-24 15:40:26 UTC
- ldconfig called in %post and %postun if required.
  Note: /sbin/ldconfig not called in libntirpc
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries

- Summary and description for -devel subpackage usually just say something like:
Summary     : Development headers for %{name}
Description :
Development headers and auxiliary files for developing with %{name}.

- Consider using %autosetup instead of %setup + %patch.

- make %{?_smp_mflags} || make %{?_smp_mflags} || make
???

- The build system seems "suboptimal". Why does it need to be patched in spec file, *and* then fixed up afterwards in %install?

- There are tests in the upstream tarball. Can they be run in %check?

Comment 3 Kaleb KEITHLEY 2015-03-24 17:45:08 UTC
> - ldconfig called in %post and %postun if required.
>   Note: /sbin/ldconfig not called in libntirpc
>   See: http://fedoraproject.org/wiki/Packaging/Guidelines#Shared_Libraries

Fixed, it was an oversight

> 
> - Summary and description for -devel subpackage usually just say something like:
> Summary     : Development headers for %{name}
> Description :
> Development headers and auxiliary files for developing with %{name}.

Fixed

> 
> - Consider using %autosetup instead of %setup + %patch.

For one patch? Docs say %autosetup is for spec files with lots of patches. Eventually the patch should go away.

> 
> - make %{?_smp_mflags} || make %{?_smp_mflags} || make
> ???

fixed

> 
> - The build system seems "suboptimal". Why does it need to be patched in spec file, *and* then fixed up afterwards in %install?

1) The patch and the fixups should eventually go away.

2) Obviously I can't patch the ../src/CMakeLists.txt to hard code install to /usr/lib64 as that will break on 32-bit archs. I could create two patches and patch accordingly on 32- and 64-bit; that seems worse IMO.

3) I haven't found the correct fix to the top-level CMakeLists.txt to install the .pc file in /usr/lib{,64}/pkgconfig. Suggested fixes are welcome.

4) The patch changes the library from a static lib to a shlib AND changes the install location from /bin to /lib. I could remove the change of the installed location but I'd still have a patch and I'd still have a fixup.

> 
> - There are tests in the upstream tarball. Can they be run in %check?

I prefer not to at this time. They aren't being run when built bundled in nfs-ganesha. I've never run them. Perhaps the upstream maintainer will decide to do that once he is sponsored as a packager and takes over the package.

New spec and SRPM at the above location.

Koji scratch builds at http://koji.fedoraproject.org/koji/taskinfo?taskID=9312202

Comment 4 Kaleb KEITHLEY 2015-03-24 19:34:20 UTC
>> - The build system seems "suboptimal". Why does it need to be patched in spec file, *and* then fixed up afterwards in %install?
>
> 1) The patch and the fixups should eventually go away.
> 
> 2) Obviously I can't patch the ../src/CMakeLists.txt to hard code install to /usr/lib64 as that will break on 32-bit archs. I could create two patches and patch accordingly on 32- and 64-bit; that seems worse IMO.
> 
> 3) I haven't found the correct fix to the top-level CMakeLists.txt to install the .pc file in /usr/lib{,64}/pkgconfig. Suggested fixes are welcome.
> 
> 4) The patch changes the library from a static lib to a shlib AND changes the install location from /bin to /lib. I could remove the change of the installed location but I'd still have a patch and I'd still have a fixup.

Or I could just remove the `make install` and install everything explicitly in the spec.

Comment 5 Kaleb KEITHLEY 2015-03-24 20:33:13 UTC
> Or I could just remove the `make install` and install everything explicitly in the spec.

Yes, I think I like that best.

New spec and SRPM at the above location

Koji scratch builds at http://koji.fedoraproject.org/koji/taskinfo?taskID=9313350

Comment 6 Zbigniew Jędrzejewski-Szmek 2015-03-25 15:21:55 UTC
Issues:
- It is better to use %post -p, see 
https://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Shared_libraries

- COPYING file is not installed. It should be installed using %license. See https://fedorahosted.org/fpc/ticket/411#comment:11 for a trick if EPEL5-6 compat is required.

- I think the License field is wrong. COPYING seems to be BSD.

- NEWS, README look like candidates for %doc.

- .pc file looks wrong, most fields are empty:

prefix=
exec_prefix=
libdir=
includedir=

Name: libntirpc
Description: New Transport Independent RPC Library
Requires:
Version:
Libs: -L -lintirpc
Cflags: -I/ntirpc

- libntirpc.src:61: W: macro-in-comment %{buildroot}
Please silence this with by doubling the percent sign.

- -devel subpackage has no dependency on the main package. It should Require it, in the same %{_isa} and %{version}.

Comment 7 Kaleb KEITHLEY 2015-03-25 19:46:13 UTC
All comments in Comment 6 addressed.

New spec and srpm at above location.

libntirpc.pc is generated by cmake, and is broken; not packaging it at this time.

Koji scratch builds at koji.fedoraproject.org/koji/taskinfo?taskID=9324832

Thank you.

Comment 8 Zbigniew Jędrzejewski-Szmek 2015-03-28 02:55:11 UTC
===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "WTFPL", "Unknown or generated", "BSD (4 clause)", "MIT/X11 (BSD like)",
     "*No copyright* BSD", "ISC", "BSD (3 clause)", "BSD (2 clause)". 23 files
     have unknown license. Detailed output of licensecheck in
     /var/tmp/1204898-libntirpc/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[!]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in libntirpc-
     devel
This should be added. The -devel package is only good with the main package for the same arch (because of the .so symlink).

[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: libntirpc-1.2.1-1.fc23.i686.rpm
          libntirpc-devel-1.2.1-1.fc23.i686.rpm
          libntirpc-1.2.1-1.fc23.src.rpm
libntirpc.i686: W: spelling-error %description -l en_US libtirpc -> librettist
libntirpc.i686: W: spelling-error %description -l en_US vc -> cc, v, c
libntirpc.i686: W: spelling-error %description -l en_US callouts -> callous, cal louts, cal-louts
libntirpc.i686: W: spelling-error %description -l en_US recv -> rec, rev, recd
libntirpc.i686: W: spelling-error %description -l en_US xprt -> expert
libntirpc-devel.i686: W: no-documentation
libntirpc.src: W: spelling-error %description -l en_US libtirpc -> librettist
libntirpc.src: W: spelling-error %description -l en_US vc -> cc, v, c
libntirpc.src: W: spelling-error %description -l en_US callouts -> callous, cal louts, cal-louts
libntirpc.src: W: spelling-error %description -l en_US recv -> rec, rev, recd
libntirpc.src: W: spelling-error %description -l en_US xprt -> expert

OK.

libntirpc.src: W: strange-permission ntirpc-1.2.1.tar.gz 0444L

A bit strange indeed, but not really harmful.

3 packages and 0 specfiles checked; 0 errors, 12 warnings.




Rpmlint (installed packages)
----------------------------
Cannot parse rpmlint output:


Requires
--------
libntirpc-devel (rpmlib, GLIBC filtered):
    libntirpc

libntirpc (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    libc.so.6
    libpthread.so.0
    rtld(GNU_HASH)



Provides
--------
libntirpc-devel:
    libntirpc-devel
    libntirpc-devel(x86-32)

libntirpc:
    libntirpc
    libntirpc(x86-32)
    libntirpc.so.1



Source checksums
----------------
https://github.com/nfs-ganesha/ntirpc/archive/v1.2.1/ntirpc-1.2.1.tar.gz :
  CHECKSUM(SHA256) this package     : efcf3be4bfc9b659019fa183f7ff7ef38160e72ca222158fad4b14dd97411a69
  CHECKSUM(SHA256) upstream package : efcf3be4bfc9b659019fa183f7ff7ef38160e72ca222158fad4b14dd97411a69


Generated by fedora-review 0.5.2 (63c24cb) last change: 2014-07-14
Command line :/usr/bin/fedora-review -o=--no-clean -m fedora-rawhide-i386 -b 1204898
Buildroot used: fedora-rawhide-i386
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, EPEL5, BATCH, DISTTAG

Everything looks good except for the one issue with the Requires described above. Please fix that before pushing. Package is APPROVED.

Comment 9 Kaleb KEITHLEY 2015-03-30 11:42:58 UTC
> Everything looks good except for the one issue with the Requires described
> above. Please fix that before pushing. Package is APPROVED.

fixed Requires, spec and srpm at above location if you care to look.

Thanks for helping get this done.

Comment 10 Kaleb KEITHLEY 2015-03-30 12:04:34 UTC
New Package SCM Request
=======================
Package Name: libntirpc
Short Description: New Transport Independent RPC Library
Upstream URL: https://github.com/nfs-ganesha/ntirpc
Owners: kkeithle
Branches: f21 f22 el6 epel7
InitialCC:

Comment 11 Patrick Uiterwijk 2015-03-30 20:21:57 UTC
Git done (by process-git-requests).

Comment 12 Fedora Update System 2015-03-31 12:48:54 UTC
libntirpc-1.2.1-1.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/libntirpc-1.2.1-1.fc22

Comment 13 Fedora Update System 2015-03-31 12:49:42 UTC
libntirpc-1.2.1-1.fc21 has been submitted as an update for Fedora 21.
https://admin.fedoraproject.org/updates/libntirpc-1.2.1-1.fc21

Comment 14 Fedora Update System 2015-03-31 12:50:22 UTC
libntirpc-1.2.1-1.el7 has been submitted as an update for Fedora EPEL 7.
https://admin.fedoraproject.org/updates/libntirpc-1.2.1-1.el7

Comment 15 Fedora Update System 2015-03-31 12:52:10 UTC
libntirpc-1.2.1-1.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/libntirpc-1.2.1-1.el6

Comment 16 Fedora Update System 2015-04-17 18:17:14 UTC
libntirpc-1.2.1-1.el6 has been pushed to the Fedora EPEL 6 stable repository.

Comment 17 Fedora Update System 2015-04-17 18:18:15 UTC
libntirpc-1.2.1-1.el7 has been pushed to the Fedora EPEL 7 stable repository.

Comment 18 Fedora Update System 2015-04-21 18:41:28 UTC
libntirpc-1.2.1-1.fc22 has been pushed to the Fedora 22 stable repository.

Comment 19 Fedora Update System 2015-04-21 19:18:37 UTC
libntirpc-1.2.1-1.fc21 has been pushed to the Fedora 21 stable repository.


Note You need to log in before you can comment on or make changes to this bug.